
unit ExcUnit;

interface

  function  SetExceptionHandler : word;
  procedure ResetExceptionHandler;
  procedure RaiseException(Exception : word);

implementation

  const Levels = 100;
  var   Stack : array[0..Levels*4] of word;
        StackPointer : word;

  function SetExceptionHandler : word; assembler;
  asm
    mov   DI,StackPointer
    add   DI,8
    mov   StackPointer,DI
    add   DI,offset Stack-8
    mov   SI,SP
    mov   AX,DS
    mov   ES,AX
    cld
    mov   AX,BP
    stosw                         { +0(2)  BP }
    SegSS movsw                   { +2(2)  CS }
    SegSS movsw                   { +4(2)  IP }
    mov   AX,SI
    stosw                         { +6(2)  SP }
    xor   AX,AX                   { Result := 0 }
  end;

  procedure ResetExceptionHandler; assembler;
  asm
    sub   StackPointer,8   { ⪫ । ஢ }
  end;

  procedure RaiseException(Exception : word); assembler;
  asm
    mov   BX,StackPointer
    add   BX,offset Stack-8
    mov   AX,Exception
    mov   BP,[BX]
    mov   SP,[BX+6]
    jmp   dword ptr [BX+2]
  end;


begin
  StackPointer := 0;
end
.

